//Bibliotecas para a integrao
#include <jni.h>
#include "NativeGlove.h"


#include <stdio.h>
#include <string.h>
#ifdef WIN32
#include <windows.h> // for Sleep
#else
#include <unistd.h>  // for usleep
#endif

//Biblioteca do fabricante
#include "fglove.h"

	char    *szPort    = NULL;
	char	szPortToOpen[6];
	
	//Varivel que retorna um valor se a conexao foi bem-sucedida ou no
	int verify = 0;

	//Ponteiro que representa o dispositivo luva de dados
	fdGlove *pGlove    = NULL;
	int NumSensors = 5;
	unsigned short *data = new unsigned short(5);
	int      i;
/*--------------------------------------------------------------------------*/



//Funo para iniciar comunicao com a luva de dados
JNIEXPORT jint JNICALL Java_ViMeT_NativeGlove_openGlove(JNIEnv *env, jobject obj)
{
	#ifdef WIN32
		szPort = "USB";
	#else
		szPort = "/dev/fglove";
	#endif
	
	strcpy(szPortToOpen,szPort);

	if (strcmp(szPort,"USB") == 0)
	{
		unsigned short aPID[5];
		int nNumFound = 5;

		//Verifica nas portas USB Data Gloves disponveis
		fdScanUSB(aPID,nNumFound);

		for (int c = 0; c < nNumFound; c++)
		{
			printf("Luvas disponveis nas portas USB:\n");
			printf("%i - ",c);
			switch (aPID[c])
			{
				case DG14U_R:
					printf("Data Glove 14 Ultra Right\n");
					break;
				case DG14U_L:
					printf("Data Glove 14 Ultra Left\n");
					break;
				case DG5U_R:
					printf("Data Glove 5 Ultra Right\n");
					break;
				case DG5U_L:
					printf("Data Glove 5 Ultra Left\n");
					break;
				default:
					printf("Desconhecida\n");
			}
		}

		sprintf(szPortToOpen,"USB%i",0);
		fdOpen(szPortToOpen);

	}

	if (NULL == (pGlove = fdOpen( szPortToOpen))) 
	{
		//printf("Falha na conexao com a luva de dados 5DT Ultra");
		verify = -1;
	}
	else
	{
		NumSensors = fdGetNumSensors(pGlove);
		verify = 1;
	}

	return verify;

}

//Fecha comunicao com a luva
JNIEXPORT void JNICALL Java_ViMeT_NativeGlove_closeGlove(JNIEnv *env, jobject obj)
{
	delete[] data;
	fdClose( pGlove );
}

//Obtm o valor de todos os sensores
JNIEXPORT jshortArray JNICALL Java_ViMeT_NativeGlove_getRawSensorData(JNIEnv *env, jobject obj)
{
	jshortArray result = env->NewShortArray(NumSensors);
	fdGetSensorRawAll(pGlove,data);
	env->SetShortArrayRegion(result,0,NumSensors,(jshort*)data);
	return result;
}

//Obtm a escala de todos os sensores
JNIEXPORT jfloatArray JNICALL Java_ViMeT_NativeGlove_getScaledSensorData(JNIEnv *env, jobject obj)
{
	jfloatArray array = env->NewFloatArray(NumSensors);
	jfloat* elements = env->GetFloatArrayElements(array,0);
	fdGetSensorScaledAll(pGlove,(float*)elements);
	return array;
}

//Permite a calibrao em um determinado intervalo de valores
JNIEXPORT void JNICALL Java_ViMeT_NativeGlove_setCalibration(JNIEnv *env, jobject obj, jshort upper, jshort lower)
{
	fdSetCalibration(pGlove,NumSensors,upper,lower);
}

//Obtm o nmero do gesto pr-definido pelo fabricante
JNIEXPORT jint JNICALL Java_ViMeT_NativeGlove_getGesture(JNIEnv *env, jobject obj)
{
	jint gesture = fdGetGesture(pGlove);
	return gesture;
}
/*--------------------------------------------------------------------------*/
